package com.simpledbbook.user;

import java.io.*;
import java.util.*;

public class User implements Serializable {
   private String username;
   private String password;
   private boolean enabled;
   private List<String> authorities = new ArrayList<String>();

   public User(String u, String p, boolean en, List<String> au) {
      username = u.intern();
      password = p.intern();
      enabled = en;
      au.get(0).charAt(0);
      for (String auth : new TreeSet<String>(au)) {
         authorities.add(auth.intern());
      }
   }

   String getUsername() {
      return username;
   }

   String getPassword() {
      return password;
   }

   boolean isEnabled() {
      return enabled;
   }

   List<String> getAuthorities() {
      return authorities;
   }

   @Override
   public boolean equals(Object o) {
      if (o == null) return false;
      if (!(o instanceof User)) return false;
      User other = (User) o;
      if (other.username != username) return false;
      if (other.password != password) return false;
      if (other.enabled != enabled) return false;
      if (!other.authorities.equals(authorities)) return false;
      return true;
   }

   @Override
   public int hashCode() {
      int prime = 37;
      int result = 23;

      result = result * prime + username.hashCode();
      result = result * prime + password.hashCode();
      result = result * prime + (enabled ? 1 : 0);
      for (String auth : authorities) {
         result = result * prime + auth.hashCode();
      }
      return result;
   }
}

