package com.simpledbbook;

import java.util.List;
import java.util.Map;

public interface ISimpleDB {

  void createDomain(String domainName);
  
  void deleteDomain(String domainName);
  
  List<String> listDomains();

  Map<String, Long> domainMetadata(String domain);

  void batchPut(String domain, List<Item> items);

  void put(String domain, Item item);

  void putIfNotExists(String domain, Item item, String expectedName);

  void putIfExists(String domain, Item item, String expectedName,
      String expectedValue);

  void delete(String domain, Item item);

  void deleteIfNotExists(String domain, Item item, String expected);

  void deleteIfExists(String domain, Item item, String expectedName,
      String expectedValue);

  Item get(String domain, String itemName, String... atts);

  Item getConsistent(String domain, String itemName, String... atts);

  List<Item> select(String select);

  List<Item> selectConsistent(String select);

  boolean hasNextPage();

  List<Item> getNextPage();

  List<Item> getNextPageConsistent();
}