package com.simpledbbook.metadata;

import java.util.*;

public class AppConfig {

    private List<String> domainList;
    private int bitCount;
    private int bitMask;
    private String serviceURL;

    private AppConfig(String appName, int bits, String... domains) {
        bitCount = bits;
        bitMask = (int) (Math.pow(2, bitCount) - 1);
        domainList = Arrays.asList(domains);
    }

    public String getDomain(int hash) {
        return domainList.get(hash & bitMask);
    }

    public String getServiceURL() {
      return serviceURL;
    }
}
